-----------------------------------------------------------------------------------------------
-- Client Lua Script for Autorepair
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "string"
require "math"
require "Sound"
require "Item"
require "Money"
require "GameLib"
 
-----------------------------------------------------------------------------------------------
-- Autorepair Module Definition
-----------------------------------------------------------------------------------------------
local Autorepair = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function Autorepair:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function Autorepair:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		"Vendor",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- Autorepair OnLoad
-----------------------------------------------------------------------------------------------
function Autorepair:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("Autorepair.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- Autorepair OnDocLoaded
-----------------------------------------------------------------------------------------------
function Autorepair:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	   	Apollo.RegisterSlashCommand("autorepair", "OnAutorepairOn", self)
		Apollo.RegisterEventHandler("InvokeVendorWindow", "OnInvokeVendorWindow", self)
		self.vendor = Apollo.GetAddon("Vendor")
	end
end

-----------------------------------------------------------------------------------------------
-- Autorepair Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/autorepair"
function Autorepair:OnAutorepairOn()
	
end

function Autorepair:OnInvokeVendorWindow(unitArg)
	local bIsRepairVendor = IsRepairVendor(unitArg)
	if bIsRepairVendor then
		self:RepairAll(unitArg)
	end
end

-----------------------------------------------------------------------------------------------
-- Repair Functions
-----------------------------------------------------------------------------------------------
function Autorepair:RepairAll(unitArg)
	RepairAllItemsVendor()
end

-----------------------------------------------------------------------------------------------
-- AutorepairForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function Autorepair:OnOK()
	self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function Autorepair:OnCancel()
	self.wndMain:Close() -- hide the window
end


-----------------------------------------------------------------------------------------------
-- Autorepair Instance
-----------------------------------------------------------------------------------------------
local AutorepairInst = Autorepair:new()
AutorepairInst:Init()
